## pyviennacl 1.0.2+dfsg

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PyViennaCL.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PyViennaCL.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/PyViennaCL"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/PyViennaCL"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== external/boost_numpy/libs/numpy/doc/CMakeLists.txt ===
project(doc-html)
file(GLOB NUMPY_DOC_DEPS conf.py *.rst)
message( STATUS "NUMPY_DOC_DEPS=${NUMPY_DOC_DEPS}" )

# add_custom_target(doc-html make -C ${PROJECT_SOURCE_DIR} html BUILDDIR=${PROJECT_BINARY_DIR}/_build)
#
# this custom target is a cross-platform python/sphinx way to
# replicate what the above make command is doing.
#
add_custom_target(doc-html
  ${SPHINX_BUILD}
     -b html 
     -c ${CMAKE_CURRENT_SOURCE_DIR}
     -d .doctrees
     ${CMAKE_CURRENT_SOURCE_DIR}
     html
  
  DEPENDS ${NUMPY_DOC_DEPS}
  WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
  COMMENT "Generating HTML Documentation"
)

SET_PROPERTY(TARGET doc-html PROPERTY FOLDER "doc")

install(DIRECTORY ${PROJECT_BINARY_DIR}/html
  DESTINATION share/doc/libboost_numpy 
  OPTIONAL
  )

if (PDFLATEX_COMPILER)
  project(doc-pdf)

  add_custom_target(doc-pdf
    ${SPHINX_BUILD}
      -b latex 
      -c ${CMAKE_CURRENT_SOURCE_DIR}
      -d .doctrees
      ${CMAKE_CURRENT_SOURCE_DIR}
      latex
    
    COMMAND ${PDFLATEX_COMPILER} --include-directory=latex --output-directory=latex latex/BoostNumPy.tex 
    COMMAND ${PDFLATEX_COMPILER} --include-directory=latex --output-directory=latex latex/BoostNumPy.tex 

    DEPENDS ${NUMPY_DOC_DEPS}
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    COMMENT "Generating Latex-pdf Documentation"
    )

  SET_PROPERTY(TARGET doc-pdf PROPERTY FOLDER "doc")

  install(FILES ${PROJECT_BINARY_DIR}/latex/BoostNumPy.pdf
    DESTINATION share/doc/libboost_numpy
    OPTIONAL
    )

endif()

=== external/boost_numpy/libs/numpy/example/CMakeLists.txt ===
# custom macro with most of the redundant code for making a python example module
macro( addPythonExe _name _srccpp )
  ADD_EXECUTABLE(${_name} ${_srccpp})
  
  # make the pyd library link against boost_numpy python and boost
  TARGET_LINK_LIBRARIES(${_name} boost_numpy ${PYTHON_LIBRARIES} ${Boost_LIBRARIES})
  
  # put the example target into a VS solution folder named example (should
  # be a no-op for Linux)
  SET_PROPERTY(TARGET ${_name} PROPERTY FOLDER "example")
endmacro()

macro( addPythonMod _name _srccpp )
  PYTHON_ADD_MODULE(${_name} ${_srccpp})
  
  # make the pyd library link against boost_numpy python and boost
  TARGET_LINK_LIBRARIES(${_name} boost_numpy ${PYTHON_LIBRARIES} ${Boost_LIBRARIES})
  
  # put the example target into a VS solution folder named example (should
  # be a no-op for Linux)
  SET_PROPERTY(TARGET ${_name} PROPERTY FOLDER "example")
endmacro()

addPythonMod(gaussian gaussian.cpp)
addPythonExe(dtype dtype.cpp)
addPythonExe(fromdata fromdata.cpp)
addPythonExe(ndarray ndarray.cpp)
addPythonExe(simple simple.cpp)
addPythonExe(ufunc ufunc.cpp)
addPythonExe(wrap wrap.cpp)

# # installation logic (skip until it is better thought out)
# set(DEST_EXAMPLE boost.numpy/example)
#
# # install executables demonstrating embedding python
# install(TARGETS dtype fromdata ndarray simple ufunc wrap RUNTIME
#   DESTINATION ${DEST_EXAMPLE}
#   ${INSTALL_PERMSSIONS_RUNTIME}
#   )
#
# # install extension module
# install(TARGETS gaussian LIBRARY
#   DESTINATION ${DEST_EXAMPLE}
#   ${INSTALL_PERMSSIONS_RUNTIME}
#   )
#
# # install source file using the extension module
# install(FILES demo_gaussian.py 
#   DESTINATION ${DEST_EXAMPLE}
#   ${INSTALL_PERMSSIONS_SRC}
#   )

=== external/boost_numpy/libs/numpy/src/CMakeLists.txt ===
add_library(boost_numpy ${LIBRARY_TYPE}
  # header files
  ../../../boost/numpy/dtype.hpp
  ../../../boost/numpy/internal.hpp
  ../../../boost/numpy/invoke_matching.hpp
  ../../../boost/numpy/matrix.hpp
  ../../../boost/numpy/ndarray.hpp
  ../../../boost/numpy/numpy_object_mgr_traits.hpp
  ../../../boost/numpy/scalars.hpp
  ../../../boost/numpy/ufunc.hpp

  # source files (in current directory)
  dtype.cpp
  scalars.cpp
  ndarray.cpp
  matrix.cpp
  ufunc.cpp
  numpy.cpp
)

TARGET_LINK_LIBRARIES(boost_numpy ${Boost_LIBRARIES})

install(TARGETS boost_numpy 
  ARCHIVE DESTINATION lib 
  LIBRARY DESTINATION lib 
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== external/boost_numpy/libs/numpy/test/CMakeLists.txt ===
project(BoostNumpyTests)

if (WIN32)
  set(runCmakeTest runCmakeTest.bat)
  foreach(cfg ${CMAKE_CONFIGURATION_TYPES})
    message( STATUS "configuring runCmakeTest for cfg=${cfg}" )
    CONFIGURE_FILE( ${runCmakeTest}.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${cfg}/${runCmakeTest} @ONLY )
  endforeach()
else()
  set(runCmakeTest runCmakeTest.sh)
  CONFIGURE_FILE( ${runCmakeTest}.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${runCmakeTest} @ONLY )
endif()

set( TEST_SOURCE_DIR ${PROJECT_SOURCE_DIR} )
set( TestCommand ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${runCmakeTest} )

# custom macro with most of the redundant code for making a python test
macro( addPythonTest _name _srcpy )
  # make the pyd library link against boost_numpy python and boost
  TARGET_LINK_LIBRARIES(${_name} boost_numpy ${PYTHON_LIBRARIES} ${Boost_LIBRARIES})
  
  # make a test of the module using the python source file in the test directory
  ADD_TEST(${_name} ${TestCommand} ${TEST_SOURCE_DIR}/${_srcpy})

  # set the regex to use to recognize a failure since `python testfoo.py`
  # does not seem to return non-zero with a test failure
  set_property(TEST ${_name} PROPERTY FAIL_REGULAR_EXPRESSION "ERROR\\:" "ImportError\\: DLL load failed\\: " )

  # put the test target into a VS solution folder named test (should
  # be a no-op for Linux)
  SET_PROPERTY(TARGET ${_name} PROPERTY FOLDER "test")
endmacro()

PYTHON_ADD_MODULE(dtype_mod dtype_mod.cpp)
addPythonTest( dtype_mod dtype.py )

PYTHON_ADD_MODULE(indexing_mod indexing_mod.cpp)
addPythonTest( indexing_mod indexing.py )

PYTHON_ADD_MODULE(ndarray_mod ndarray_mod.cpp)
addPythonTest( ndarray_mod ndarray.py )

PYTHON_ADD_MODULE(shapes_mod shapes_mod.cpp)
addPythonTest( shapes_mod shapes.py )

PYTHON_ADD_MODULE(templates_mod templates_mod.cpp)
addPythonTest( templates_mod templates.py )

PYTHON_ADD_MODULE(ufunc_mod ufunc_mod.cpp)
addPythonTest( ufunc_mod ufunc.py )

# installation logic (skip until it is better thought out)
# set(DEST_TEST boost.numpy/test)
#
# # copy the extension modules to DEST_TEST
# install(TARGETS dtype_mod indexing_mod ndarray_mod shapes_mod templates_mod ufunc_mod LIBRARY
#   DESTINATION ${DEST_TEST}
#   ${INSTALL_PERMSSIONS_RUNTIME}
#   )
#
# # copy the source test python modules to DEST_TEST too
# install(FILES dtype.py indexing.py ndarray.py shapes.py templates.py ufunc.py
#   DESTINATION ${DEST_TEST}
#   ${INSTALL_PERMSSIONS_SRC}
#   )

=== debian/changelog ===
pyviennacl (1.0.2+dfsg-1build3) xenial; urgency=medium

  * No-change rebuild to drop python3.4 support.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Jan 2016 00:43:13 +0000

pyviennacl (1.0.2+dfsg-1build2) wily; urgency=medium

  * No-change rebuild using boost 1.58.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 12:55:32 +0000

pyviennacl (1.0.2+dfsg-1build1) wily; urgency=medium

  * No-change rebuild for python3.5 transition

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 23 Jul 2015 07:15:58 +0000

pyviennacl (1.0.2+dfsg-1) unstable; urgency=medium

  * [34ed3ae] New upstream release 1.0.2
  * [6c25340] debian/copyright: exclude external files
  * [62374c3] Fix debian/rules to build cleanly given excluded files
  * [248193f] Add dversionmangle to watch file
  * [5bffadd] Install upstream changelog

 -- Toby Smithe <tsmithe@ubuntu.com>  Tue, 06 May 2014 10:22:39 +0100

pyviennacl (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #732921)

 -- Toby Smithe <tsmithe@ubuntu.com>  Mon, 10 Mar 2014 18:31:51 +0000

=== debian/control ===
Source: pyviennacl
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Toby Smithe <tsmithe@ubuntu.com>
Build-Depends: debhelper (>= 9), dh-python, cmake, python-all-dev, python3-all-dev,
 python-setuptools, python3-setuptools, python-numpy, python3-numpy, python-sphinx,
 python3-sphinx, libboost-python-dev, opencl-headers, ocl-icd-libopencl1 | libopencl1,
 libviennacl-dev (>= 1.5.1)
Standards-Version: 3.9.5
Homepage: http://viennacl.sourceforge.net/pyviennacl.html
Vcs-Git: git://git.debian.org/debian-science/packages/pyviennacl.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/pyviennacl.git

Package: python-pyviennacl
Architecture: any
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}, python-scipy
Suggests: pyviennacl-doc
Description: Python bindings for ViennaCL linear algebra library (for Python 2)
 The Vienna Computing Library (ViennaCL) is a free open-source
 scientific computing library written in C++ and provides CUDA, OpenCL
 and OpenMP computing backends. It enables simple, high-level access
 to the vast computing resources available on parallel architectures
 such as GPUs and is primarily focused on common linear algebra
 operations (BLAS levels 1, 2 and 3) and the solution of large systems
 of equations by means of iterative methods with optional
 preconditioners.
 .
 This package provides the Python 2 bindings for ViennaCL, PyViennaCL,
 letting you harness the computational power of ViennaCL in the
 context of the Python scientific ecosystem.

Package: python3-pyviennacl
Architecture: any
Depends: ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}, python3-scipy
Suggests: pyviennacl-doc
Description: Python bindings for ViennaCL linear algebra library (for Python 3)
 The Vienna Computing Library (ViennaCL) is a free open-source
 scientific computing library written in C++ and provides CUDA, OpenCL
 and OpenMP computing backends. It enables simple, high-level access
 to the vast computing resources available on parallel architectures
 such as GPUs and is primarily focused on common linear algebra
 operations (BLAS levels 1, 2 and 3) and the solution of large systems
 of equations by means of iterative methods with optional
 preconditioners.
 .
 This package provides the Python 3 bindings for ViennaCL, PyViennaCL,
 letting you harness the computational power of ViennaCL in the
 context of the Python scientific ecosystem.

Package: pyviennacl-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: HTML documentation for PyViennaCL
 The Vienna Computing Library (ViennaCL) is a free open-source
 scientific computing library written in C++ and provides CUDA, OpenCL
 and OpenMP computing backends. It enables simple, high-level access
 to the vast computing resources available on parallel architectures
 such as GPUs and is primarily focused on common linear algebra
 operations (BLAS levels 1, 2 and 3) and the solution of large systems
 of equations by means of iterative methods with optional
 preconditioners.
 .
 This package provides the HTML documentation for PyViennaCL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PYBUILD_NAME=pyviennacl
export PYBUILD_DISABLE=test
export PYBUILD_BEFORE_CLEAN=echo USE_SHIPPED_BOOST = False | tee siteconf.py
export PYBUILD_AFTER_CLEAN=rm Makefile siteconf*py || true
export PYBUILD_BEFORE_BUILD=ln -s {dir}/siteconf{version}.py {dir}/siteconf.py
export PYBUILD_AFTER_BUILD=rm {dir}/siteconf.py
export PYBUILD_BEFORE_INSTALL=ln -s {dir}/siteconf{version}.py {dir}/siteconf.py
export PYBUILD_AFTER_INSTALL=rm {dir}/siteconf.py
export PYBUILD_INSTALL_ARGS=--install-layout deb

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

# Sphinx documentation is architecture-independent
override_dh_sphinxdoc-arch:

override_dh_auto_configure:
	PYBUILD_SYSTEM=custom \
	PYBUILD_CONFIGURE_ARGS="cd {dir}; \
		SITECONF=siteconf{version}.py {interpreter} configure.py --no-use-shipped-boost --no-use-shipped-viennacl" \
		dh_auto_configure
	rm Makefile

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_auto_install-arch:
	dh_auto_install
	dh_numpy
	dh_numpy3

override_dh_auto_install-indep:
	PYTHONPATH=debian/python-pyviennacl/usr/lib/python2.7/dist-packages python doc/build-doc.py
	mkdir -p debian/pyviennacl-doc/usr/share/doc/pyviennacl-doc
	cp -r build/doc debian/pyviennacl-doc/usr/share/doc/pyviennacl-doc/html
	dh_sphinxdoc

override_dh_python3:
	dh_python3
	rm -rf debian/python3-pyviennacl/usr/lib/python3.?

#override_dh_auto_test:
#	PYBUILD_SYSTEM=custom \
#	PYBUILD_TEST_ARGS="set -x; cd {build_dir}; cmake -DPYTHONPATH={build_dir}/pyviennacl/build/lib.linux-`uname -p`-{version} {dir}; ctest -VV" \
#		dh_auto_test

=== debian/watch ===
version=3
opts=uversionmangle=s/(rc|dev|a|b|c)/~$1/,dversionmangle=s/\+dfsg\d*$// \
https://pypi.python.org/packages/source/p/pyviennacl/pyviennacl-(.*)\.(?:tar\.gz|zip|tar\.bz2)
